<?php
define('BUFFERED_SYSTEM_MAXBUFF', 4*1024); // Maximum read buffer in kilobytes
/* System-like command that returns output of executed command.
 *
 * $command   command to be executed with popen
 * $errorcode is set to errorcode of executed command
 * $input     gets written to stdin of executed program
 */
function buffered_system($command, &$errorcode, $input='') {
  // Temporary file for command output.  BSD would support
  // bidirectional (mode w+) pipes...
  $tmpfile = tempnam('/tmp','');
  // Open pipe
  if (!($p=popen("($command)2>&1>$tmpfile","w"))) {
    $errorcode = 126;
    return 'Failed opening pipe.';
  }
  // Write input
  fputs($p, $input);
  // Close pipe and set errorcode
  $errorcode = (pclose($p)>>8)&0xFF;
  // Get command output from temporary file 
  if ( function_exists('file_get_contents') ) {
    $output = @file_get_contents($tmpfile);
  } else {
    $output = join('', @file($tmpfile));
  }
  // Remove temporary file
  unlink($tmpfile);
  return $output;
}

?>
